/*
 *  The Mana World
 *  Copyright 2004 The Mana World Development Team
 *
 *  This file is part of The Mana World.
 *
 *  The Mana World is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  any later version.
 *
 *  The Mana World is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with The Mana World; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  $Id: game.h,v 1.36 2005/07/28 15:14:21 der_doener Exp $
 */

#ifndef _TMW_GAME_H
#define _TMW_GAME_H

#define SPEECH_TIME 80
#define SPEECH_MAX_TIME 100

#define LOCK 254
#define IDLE 255

#define DIR_NONE -1
#define SOUTH 0
#define SW    1
#define WEST  2
#define NW    3
#define NORTH 4
#define NE    5
#define EAST  6
#define SE    7

extern char map_path[480];
extern int fps, frame, current_npc;
extern volatile int tick_time;
extern int server_tick;
extern bool displayPathToMouse;
extern int startX, startY;

enum {
    JOY_UP,
    JOY_DOWN,
    JOY_LEFT,
    JOY_RIGHT,
    JOY_BTN0,
    JOY_BTN1,
    JOY_BTN2,
    JOY_BTN3,
    JOY_BTN4,
    JOY_BTN5,
    JOY_BTN6,
    JOY_BTN7,
    JOY_BTN8,
    JOY_BTN9,
    JOY_BTN10,
    JOY_BTN11
};

/**
 * Main game loop
 */
void game();

/**
 * Check user input
 */
void do_input();

/**
 * Parse data received from map server into input buffer
 */
void do_parse();

/**
 * Clean the engine
 */
void do_exit();

/**
 * Calculate packet length
 */
int get_packet_length(short);

/**
 * Returns elapsed time. (Warning: very unsafe function, it supposes the delay
 * is always < 10 seconds)
 */
int get_elapsed_time(int start_time);

#endif
